# Read in and write EER JSON objects for transformations
# Authors: St John Grimbly
# Date Created: 30 August 2019
# Version: Alpha v1.0

# Launch virtual environment in terminal using 'source venv/bin/activate'

from flask import Flask, request, jsonify
from flask_cors import CORS

import ARM_To_EER
import EER_To_ARM

WebServer = Flask(__name__)
cors = CORS(WebServer)


@WebServer.route('/')
def index():
    '''Index page for the server root directory.'''
    # TO DO: Display Markdown user guide for this application
    return ("WELCOME. THIS IS A SERVER ENDPOINT FOR CONVERTING BETWEEN " 
            "ARM AND EER MODELS.")

@WebServer.route('/api/transform', methods=['GET','POST'])
def transform_view():
    '''API endpoint for the transform method used in the JavaScript front-end.'''
    json_file = request.get_json(force=True)# JSON Dictionary
    
    #json_file = request.json
    if not json_file:
        return "No file"
    
    if 'entityTypes' in json_file:
        return EER_To_ARM.transform(json_file)
    else:
        return ARM_To_EER.transform(json_file)

if __name__ == '__main__':
    WebServer.run(debug=True, host='127.0.0.1')
